/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

const { classes: Cc, interfaces: Ci, utils: Cu, results: Cr } = Components;

Cu.import("resource://gre/modules/XPCOMUtils.jsm");
Cu.import("resource://gre/modules/Services.jsm");

function _log(aMessage) {
	Services.console.logStringMessage("[QueryProcessor Sample]"+aMessage);
}

let QueryProcessorSample = {
	
	init: function QPS_init() {
		this._tree = document.getElementById("main-tree");
		this._query = document.getElementById("query");
		this._connection = this._tree.builder.datasource.QueryInterface(Ci.mozIStorageConnection);
		Services.obs.addObserver(this, "http-on-modify-request", false);
	},
	
	finish: function QPS_finish() {
		Services.obs.removeObserver(this, "http-on-modify-request");
	},
	
	search: function QPS_search(aValue) {
		aValue = aValue.replace(/^ +/, "");
		if (aValue) {
			this._query.textContent = "SELECT * FROM queryprocessor_sample WHERE url LIKE '%"+ aValue.replace(/ +/g, " ").replace(/ $/, "").split(" ").join("%' AND url LIKE '%") +"%'";
		} else {
			this._query.textContent = "SELECT * FROM queryprocessor_sample";
		}
		this._tree.builder.rebuild();
	},
	
	observe: function QPS_observe(aSubject, aTopic, aData) {
		let channel = aSubject.QueryInterface(Ci.nsIHttpChannel);
		let statement = this._connection.createStatement("INSERT INTO queryprocessor_sample VALUES (:url, :referrer)");
		statement.params.url = channel.URI.spec;
		statement.params.referrer = channel.referrer ? channel.referrer.spec : "";
		statement.execute();
		this._tree.builder.rebuild();
	}
};
